Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1789)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1791)
@@ -2407,56 +3015,85 @@
  CONTAINS
 
-
-   SUBROUTINE pmci_interpolation
-
-!
-!--   A wrapper routine for all interpolation and extrapolation actions.
-      IMPLICIT NONE
-
-!
-!--   Add IF-condition here: IF not vertical nesting
-      IF ( nest_bound_l )  THEN   !  Left border pe
-         CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                   nzb_u_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 'u' )
-         CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                   nzb_v_inner, logc_v_l, logc_ratio_v_l, nzt_topo_nestbc_l, 'l', 'v' )
-         CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                   nzb_w_inner, logc_w_l, logc_ratio_w_l, nzt_topo_nestbc_l, 'l', 'w' )
-         CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                   nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 'e' )
-         CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                   nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 's' )
-         IF ( humidity  .OR.  passive_scalar )  THEN
-            CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
-                                      nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 's' )
-         ENDIF
-         IF ( nesting_mode == 'one-way' )  THEN
-            CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
-            CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
-            CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
-            CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
-            CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
-            IF ( humidity  .OR.  passive_scalar )  THEN
-               CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
-            ENDIF
-         ENDIF
-      ENDIF
-      IF ( nest_bound_r )  THEN   !  Right border pe
-         CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                   nzb_u_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 'u' )
-         CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                   nzb_v_inner, logc_v_r, logc_ratio_v_r, nzt_topo_nestbc_r, 'r', 'v' )
-         CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                   nzb_w_inner, logc_w_r, logc_ratio_w_r, nzt_topo_nestbc_r, 'r', 'w' )
-         CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                   nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 'e' )
-         CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                   nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 's' )
-         IF ( humidity  .OR.  passive_scalar )  THEN
-            CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
-                                      nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 's' )
-         ENDIF
-         IF ( nesting_mode == 'one-way' )  THEN
-            CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
+    SUBROUTINE pmci_interpolation
+
+!
+!--    A wrapper routine for all interpolation and extrapolation actions
+       IMPLICIT NONE
+
+!
+!--    Add IF-condition here: IF not vertical nesting
+!--    Left border pe:
+       IF ( nest_bound_l )  THEN
+          CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_l,   &
+                                    logc_ratio_u_l, nzt_topo_nestbc_l, 'l',    &
+                                    'u' )
+          CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
+                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_l,   &
+                                    logc_ratio_v_l, nzt_topo_nestbc_l, 'l',    &
+                                    'v' )
+          CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_l,   &
+                                    logc_ratio_w_l, nzt_topo_nestbc_l, 'l',    &
+                                    'w' )
+          CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_l,   &
+                                    logc_ratio_u_l, nzt_topo_nestbc_l, 'l',    &
+                                    'e' )
+          CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_l,   &
+                                    logc_ratio_u_l, nzt_topo_nestbc_l, 'l',    &
+                                    's' )
+          IF ( humidity  .OR.  passive_scalar )  THEN
+             CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
+                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
+                                       logc_u_l, logc_ratio_u_l,               &
+                                       nzt_topo_nestbc_l, 'l', 's' )
+          ENDIF
+
+          IF ( nesting_mode == 'one-way' )  THEN
+             CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
+             CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
+             CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
+             CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
+             CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
+             IF ( humidity  .OR.  passive_scalar )  THEN
+                CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
+             ENDIF
+          ENDIF
+
+       ENDIF
+!
+!--    Right border pe
+       IF ( nest_bound_r )  THEN
+          CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_r,   &
+                                    logc_ratio_u_r, nzt_topo_nestbc_r, 'r',    &
+                                    'u' )
+          CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
+                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_r,   &
+                                    logc_ratio_v_r, nzt_topo_nestbc_r, 'r',    &
+                                    'v' )
+          CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_r,   &
+                                    logc_ratio_w_r, nzt_topo_nestbc_r, 'r',    &
+                                    'w' )
+          CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_r,   &
+                                    logc_ratio_u_r, nzt_topo_nestbc_r, 'r',    &
+                                    'e' )
+          CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_r,   &
+                                    logc_ratio_u_r, nzt_topo_nestbc_r, 'r',    &
+                                    's' )
+          IF ( humidity  .OR.  passive_scalar )  THEN
+             CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
+                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
+                                       logc_u_r, logc_ratio_u_r,               &
+                                       nzt_topo_nestbc_r, 'r', 's' )
+          ENDIF
+
+          IF ( nesting_mode == 'one-way' )  THEN
+             CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
              CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'r', 'v' )
              CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'r', 'w' )
@@ -2467,20 +3104,36 @@
              ENDIF
           ENDIF
-       ENDIF
-       IF ( nest_bound_s )  THEN   !  South border pe
-          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                    nzb_u_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 'u' )
-          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                    nzb_v_inner, logc_v_s, logc_ratio_v_s, nzt_topo_nestbc_s, 's', 'v' )
-          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                    nzb_w_inner, logc_w_s, logc_ratio_w_s, nzt_topo_nestbc_s, 's', 'w' )
-          CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                    nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 'e' )
-          CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                    nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 's' )
+
+       ENDIF
+!
+!--    South border pe
+       IF ( nest_bound_s )  THEN
+          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_s,   &
+                                    logc_ratio_u_s, nzt_topo_nestbc_s, 's',    &
+                                    'u' )
+          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
+                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_s,   &
+                                    logc_ratio_v_s, nzt_topo_nestbc_s, 's',    &
+                                    'v' )
+          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_s,   &
+                                    logc_ratio_w_s, nzt_topo_nestbc_s, 's',    &
+                                    'w' )
+          CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_s,   &
+                                    logc_ratio_u_s, nzt_topo_nestbc_s, 's',    &
+                                    'e' )
+          CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_s,   &
+                                    logc_ratio_u_s, nzt_topo_nestbc_s, 's',    &
+                                    's' )
           IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
-                                       nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 's' )
+             CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
+                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
+                                       logc_u_s, logc_ratio_u_s,               &
+                                       nzt_topo_nestbc_s, 's', 's' )
           ENDIF
+
           IF ( nesting_mode == 'one-way' )  THEN
              CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 's', 'u' )
@@ -2493,20 +3146,36 @@
              ENDIF
           ENDIF
-       ENDIF
-       IF ( nest_bound_n )  THEN   !  North border pe
-          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                    nzb_u_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 'u' )
-          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                    nzb_v_inner, logc_v_n, logc_ratio_v_n, nzt_topo_nestbc_n, 'n', 'v' )
-          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                    nzb_w_inner, logc_w_n, logc_ratio_w_n, nzt_topo_nestbc_n, 'n', 'w' )
-          CALL pmci_interp_tril_sn( e,  ec,  ico,jco,kco,r1xo,r2xo,r1yo,r2yo,r1zo,r2zo,                  &
-                                    nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 'e' )
-          CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                    nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 's' )
+
+       ENDIF
+!
+!--    North border pe
+       IF ( nest_bound_n )  THEN
+          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_u_inner, logc_u_n,   &
+                                    logc_ratio_u_n, nzt_topo_nestbc_n, 'n',    &
+                                    'u' )
+          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,  &
+                                    r2yv, r1zo, r2zo, nzb_v_inner, logc_v_n,   &
+                                    logc_ratio_v_n, nzt_topo_nestbc_n, 'n',    &
+                                    'v' )
+          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zw, r2zw, nzb_w_inner, logc_w_n,   &
+                                    logc_ratio_w_n, nzt_topo_nestbc_n, 'n',    &
+                                    'w' )
+          CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_n,   &
+                                    logc_ratio_u_n, nzt_topo_nestbc_n, 'n',    &
+                                    'e' )
+          CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+                                    r2yo, r1zo, r2zo, nzb_s_inner, logc_u_n,   &
+                                    logc_ratio_u_n, nzt_topo_nestbc_n, 'n',    &
+                                    's' )
           IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_sn( q, qc, ico,jco,kco,r1xo,r2xo,r1yo,r2yo,r1zo,r2zo,                 &
-                                       nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 's' )
+             CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, &
+                                       r2yo, r1zo, r2zo, nzb_s_inner,          &
+                                       logc_u_n, logc_ratio_u_n,               &
+                                       nzt_topo_nestbc_n, 'n', 's' )
           ENDIF
+
           IF ( nesting_mode == 'one-way' )  THEN
              CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 'n', 'u' )
@@ -2518,17 +3187,26 @@
                 CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 'n', 's' )
              ENDIF
+
           ENDIF
-      ENDIF
-
-!
-!--   All PEs are top-border PEs
-       CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo, 'u' )
-       CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo, 'v' )
-       CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw, 'w' )
-       CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 'e' )
-       CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 's' )
-       IF ( humidity  .OR.  passive_scalar )  THEN
-          CALL pmci_interp_tril_t( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 's' )
-       ENDIF
+
+       ENDIF
+
+!
+!--    All PEs are top-border PEs
+       CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,      &
+                                r2yo, r1zo, r2zo, 'u' )
+       CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,      &
+                                r2yv, r1zo, r2zo, 'v' )
+       CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,      &
+                                r2yo, r1zw, r2zw, 'w' )
+       CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,      &
+                                r2yo, r1zo, r2zo, 'e' )
+       CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo,      &
+                                r2yo, r1zo, r2zo, 's' )
+       IF ( humidity .OR. passive_scalar )  THEN
+          CALL pmci_interp_tril_t( q, qc, ico, jco, kco, r1xo, r2xo, r1yo,     &
+                                   r2yo, r1zo, r2zo, 's' )
+       ENDIF
+
        IF ( nesting_mode == 'one-way' )  THEN
           CALL pmci_extrap_ifoutflow_t( u,  'u' )
@@ -2541,4 +3219,5 @@
           ENDIF
       ENDIF
+
    END SUBROUTINE pmci_interpolation
 
@@ -2551,10 +3230,15 @@
       IMPLICIT NONE
 
-      CALL pmci_anterp_tophat( u,  uc,  kceu, iflu, ifuu, jflo, jfuo, kflo, kfuo, nzb_u_inner, 'u' )
-      CALL pmci_anterp_tophat( v,  vc,  kceu, iflo, ifuo, jflv, jfuv, kflo, kfuo, nzb_v_inner, 'v' )
-      CALL pmci_anterp_tophat( w,  wc,  kcew, iflo, ifuo, jflo, jfuo, kflw, kfuw, nzb_w_inner, 'w' )
-      CALL pmci_anterp_tophat( pt, ptc, kceu, iflo, ifuo, jflo, jfuo, kflo, kfuo, nzb_s_inner, 's' )
+      CALL pmci_anterp_tophat( u,  uc,  kctu, iflu, ifuu, jflo, jfuo, kflo,    &
+                               kfuo, nzb_u_inner, 'u' )
+      CALL pmci_anterp_tophat( v,  vc,  kctu, iflo, ifuo, jflv, jfuv, kflo,    &
+                               kfuo, nzb_v_inner, 'v' )
+      CALL pmci_anterp_tophat( w,  wc,  kctw, iflo, ifuo, jflo, jfuo, kflw,    &
+                               kfuw, nzb_w_inner, 'w' )
+      CALL pmci_anterp_tophat( pt, ptc, kctu, iflo, ifuo, jflo, jfuo, kflo,    &
+                               kfuo, nzb_s_inner, 's' )
       IF ( humidity  .OR.  passive_scalar )  THEN
-         CALL pmci_anterp_tophat( q, qc, kceu, iflo, ifuo, jflo, jfuo, kflo, kfuo, nzb_s_inner, 's' )
+         CALL pmci_anterp_tophat( q, qc, kctu, iflo, ifuo, jflo, jfuo, kflo,   &
+                                  kfuo, nzb_s_inner, 's' )
       ENDIF
 
@@ -2563,34 +3247,16 @@
 
 
-   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, r2z, kb, logc, logc_ratio, &
-                                  nzt_topo_nestbc, edge, var )
-
+   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
+                                   r2z, kb, logc, logc_ratio, nzt_topo_nestbc, &
+                                   edge, var )
 !
 !--   Interpolation of ghost-node values used as the client-domain boundary
-!--   conditions. This subroutine handles the left and right boundaries. 
-!--   This subroutine is based on trilinear interpolation.
-!--   Constant dz is still assumed.
-!
-!--                                   Antti Hellsten 22.2.2015.
-!
-!--   Rewritten so that all the coefficients and client-array indices are 
-!--   precomputed in the initialization phase by pmci_init_interp_tril.
-!
-!                                     Antti Hellsten 3.3.2015.
-!
-!--   Constant dz no more assumed.
-!                                     Antti Hellsten 23.3.2015.
-!
-!--   Adapted for non-flat topography. However, the near-wall velocities 
-!--   are log-corrected only over horizontal surfaces, not yet near vertical 
-!--   walls.
-!--                                   Antti Hellsten 26.3.2015.
-!
-!--   Indexing in the principal direction (i) is changed. Now, the nest-boundary 
-!--   values are interpolated only into the first ghost-node layers on each later 
-!--   boundary. These values are then simply copied to the second ghost-node layer.
-!
-!--                                   Antti Hellsten 6.10.2015.
+!--   conditions. This subroutine handles the left and right boundaries. It is
+!--   based on trilinear interpolation. Constant dz is still assumed.
+!--   TO_DO:  constant dz is an important restriction and should be checked
+!--           somewhere in order to let users not run into this trap
       IMPLICIT NONE
+
+!--   TO_DO: wrap long lines in this and the remaining interp_tril routines
       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT)          ::  f            !:
       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)                 ::  fc           !:
@@ -2615,4 +3281,5 @@
       INTEGER(iwp) ::  i       !:
       INTEGER(iwp) ::  ib      !:
+      INTEGER(iwp) ::  ibgp    !:
       INTEGER(iwp) ::  iw      !:
       INTEGER(iwp) ::  j       !:
@@ -2759,6 +3426,14 @@
 
 !
-!--   Store the boundary values also into the second ghost node layer.
-      f(0:nzt+1,nys:nyn+1,ib) = f(0:nzt+1,nys:nyn+1,i)
+!--   Store the boundary values also into the other redundant ghost node layers
+      IF ( edge == 'l' )  THEN
+         DO ibgp = -nbgp, ib
+            f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
+         ENDDO
+      ELSE IF ( edge == 'r' )  THEN
+         DO ibgp = ib, nx + nbgp
+            f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
+         ENDDO
+      ENDIF
 
    END SUBROUTINE pmci_interp_tril_lr
@@ -2823,4 +3498,5 @@
       INTEGER(iwp) ::  j       !:
       INTEGER(iwp) ::  jb      !:
+      INTEGER(iwp) ::  jbgp    !:
       INTEGER(iwp) ::  k       !:
       INTEGER(iwp) ::  kcorr   !:
@@ -2960,6 +3636,14 @@
 
 !
-!--   Store the boundary values also into the second ghost node layer.
-      f(0:nzt+1,jb,nxl:nxr+1) = f(0:nzt+1,j,nxl:nxr+1)
+!--   Store the boundary values also into the other redundant ghost node layers
+      IF ( edge == 's' )  THEN
+         DO jbgp = -nbgp, jb
+            f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
+         ENDDO
+      ELSE IF ( edge == 'n' )  THEN
+         DO jbgp = jb, ny + nbgp
+            f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
+         ENDDO
+      ENDIF
 
    END SUBROUTINE pmci_interp_tril_sn
@@ -2974,22 +3658,4 @@
 !--   This subroutine is based on trilinear interpolation.
 !--   Constant dz is still assumed.
-!
-!--                                      Antti Hellsten 23.2.2015.
-!
-!
-!--   Rewritten so that all the coefficients and client-array indices are 
-!--   precomputed in the initialization phase by pmci_init_interp_tril.
-!
-!--                                      Antti Hellsten 3.3.2015.
-!
-!--   Constant dz no more assumed.
-!--                                      Antti Hellsten 23.3.2015.
-!
-!--   Indexing in the principal direction (k) is changed. Now, the nest-boundary 
-!--   values are interpolated only into the first ghost-node layer. Actually there is 
-!--   only one ghost-node layer in the k-direction.  
-!
-!--                                      Antti Hellsten 6.10.2015.
-!
       IMPLICIT NONE
       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f     !:
